"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cloneRequest_1 = require("./cloneRequest");
/**
 * @internal
 */
function moveHeadersToQuery(request) {
    const { headers, query = {} } = typeof request.clone === "function"
        ? request.clone()
        : cloneRequest_1.cloneRequest(request);
    for (let name of Object.keys(headers)) {
        const lname = name.toLowerCase();
        if (lname.substr(0, 6) === "x-amz-") {
            query[name] = headers[name];
            delete headers[name];
        }
    }
    return Object.assign({}, request, { headers,
        query });
}
exports.moveHeadersToQuery = moveHeadersToQuery;
//# sourceMappingURL=moveHeadersToQuery.js.map