"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cloneRequest_1 = require("./cloneRequest");
const constants_1 = require("./constants");
/**
 * @internal
 */
function prepareRequest(request) {
    // Create a clone of the request object that does not clone the body
    request =
        typeof request.clone === "function"
            ? request.clone()
            : cloneRequest_1.cloneRequest(request);
    for (let headerName of Object.keys(request.headers)) {
        if (constants_1.GENERATED_HEADERS.indexOf(headerName.toLowerCase()) > -1) {
            delete request.headers[headerName];
        }
    }
    return request;
}
exports.prepareRequest = prepareRequest;
//# sourceMappingURL=prepareRequest.js.map